# Generated by notangle -ROpenRSPTestData.cmake web/UnitTesting.nw > cmake/OpenRSPTestData.cmake
include_directories(${PROJECT_BINARY_DIR})
set(OPENRSP_TEST_DATA ${PROJECT_BINARY_DIR}/OpenRSPTestData.h)
file(WRITE ${OPENRSP_TEST_DATA} "#if !defined(OPENRSP_TEST_DATA_H)\n")
file(APPEND ${OPENRSP_TEST_DATA} "#define OPENRSP_TEST_DATA_H\n\n")
file(APPEND ${OPENRSP_TEST_DATA} "#include \"qcmatrix.h\"\n\n")
# function of reading matrices from a dat file
file(APPEND ${OPENRSP_TEST_DATA} "extern QErrorCode OpenRSPTestReadMat(const char*,\n")
file(APPEND ${OPENRSP_TEST_DATA} "                                     const QInt,\n")
file(APPEND ${OPENRSP_TEST_DATA} "                                     const QInt,\n")
file(APPEND ${OPENRSP_TEST_DATA} "                                     QcMat*[]);\n\n")
# function of zeroing matrices
file(APPEND ${OPENRSP_TEST_DATA} "extern QErrorCode OpenRSPTestZeroMat(const QInt,\n")
file(APPEND ${OPENRSP_TEST_DATA} "                                     QcMat*[]);\n\n")
# atomic-orbital (AO) density matrix-based response theory
#
# unperturbed AO-based Fock matrix
get_filename_component(DMAT_HF_FOCK
                       ${LIB_OPENRSP_PATH}/tests/DMatHF/FOCK.dat
                       ABSOLUTE)
file(APPEND
     ${OPENRSP_TEST_DATA}
     "#define DMAT_HF_FOCK \"${DMAT_HF_FOCK}\"\n")
# unperturbed AO-based density matrix
get_filename_component(DMAT_HF_DENSITY
                       ${LIB_OPENRSP_PATH}/tests/DMatHF/DENSITY.dat
                       ABSOLUTE)
file(APPEND
     ${OPENRSP_TEST_DATA}
     "#define DMAT_HF_DENSITY \"${DMAT_HF_DENSITY}\"\n")
# unperturbed AO-based overlap integral matrix
get_filename_component(DMAT_OVERLAP
                       ${LIB_OPENRSP_PATH}/tests/DMatHF/OVERLAP.dat
                       ABSOLUTE)
file(APPEND
     ${OPENRSP_TEST_DATA}
     "#define DMAT_OVERLAP \"${DMAT_OVERLAP}\"\n")
# unperturbed AO-based dipole length integral matrices
get_filename_component(DMAT_DIPLEN
                       ${LIB_OPENRSP_PATH}/tests/DMatHF/DIPLEN.dat
                       ABSOLUTE)
file(APPEND
     ${OPENRSP_TEST_DATA}
     "#define DMAT_DIPLEN \"${DMAT_DIPLEN}\"\n")
# two-electron integrals contracted with perturbed AO-based density matrices
# for solving polarizability at frequency as 0.072
get_filename_component(ALPHA_GMAT_AO_HF
                       ${LIB_OPENRSP_PATH}/tests/DMatHF/AlphaGMatAOHF.dat
                       ABSOLUTE)
file(APPEND
     ${OPENRSP_TEST_DATA}
     "#define ALPHA_GMAT_AO_HF \"${ALPHA_GMAT_AO_HF}\"\n")
# response parameters for solving polarizability at frequency as 0.072
get_filename_component(ALPHA_RSPARAM_AO_HF
                       ${LIB_OPENRSP_PATH}/tests/DMatHF/AlphaRSParamAOHF.dat
                       ABSOLUTE)
file(APPEND
     ${OPENRSP_TEST_DATA}
     "#define ALPHA_RSPARAM_AO_HF \"${ALPHA_RSPARAM_AO_HF}\"\n")
file(APPEND ${OPENRSP_TEST_DATA} "\n#endif\n")
